variables:
    DOCKER_TLS_CERTDIR: ""
    DOCKER_VERSION: 20.10.21
    IMAGE_NAME: $CI_REGISTRY_IMAGE
    SOURCE:
        description: "Tag de l'image source pour la duplication"
    DEST:
        description: "Tag de l'image cible pour la duplication"

stages:
    - deployment

.template:build:
    stage: deployment
    image: docker:$DOCKER_VERSION
    services:
        - docker:$DOCKER_VERSION-dind
    before_script:
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    script:
        - docker build --pull -t $IMAGE_NAME:$IMAGE_TAG .
        - docker push $IMAGE_NAME:$IMAGE_TAG

docker:build-latest:
    extends: .template:build
    variables:
        IMAGE_TAG: latest
    rules:
        -   if: $CI_PIPELINE_SOURCE == "web" && $SOURCE && $DEST
            when: never
        -   if: $CI_PIPELINE_SOURCE == "merge_request_event"
            when: never
        -   if: $CI_PIPELINE_SOURCE == "web"
        -   if: $CI_COMMIT_BRANCH && $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

docker:build-tag:
    extends: .template:build
    variables:
        IMAGE_TAG: $CI_COMMIT_TAG
    rules:
        -   if: $CI_COMMIT_TAG

docker:tag-image:
    extends: .template:build
    script:
        - docker pull $IMAGE_NAME:$SOURCE
        - docker tag $IMAGE_NAME:$SOURCE $IMAGE_NAME:$DEST
        - docker push $IMAGE_NAME:$DEST
    rules:
        -   if: $CI_PIPELINE_SOURCE == "web" && $SOURCE && $DEST
